from irregular_chars import (
    full_to_small_width_alphanumerics,
    half_to_full_width_kanas,
    normalize_width_all,
)


def test_full_to_small_width_alphanumerics():
    assert full_to_small_width_alphanumerics("０") == "0"
    assert full_to_small_width_alphanumerics("１") == "1"
    assert full_to_small_width_alphanumerics("２") == "2"
    assert full_to_small_width_alphanumerics("３") == "3"
    assert full_to_small_width_alphanumerics("４") == "4"
    assert full_to_small_width_alphanumerics("５") == "5"
    assert full_to_small_width_alphanumerics("６") == "6"
    assert full_to_small_width_alphanumerics("７") == "7"
    assert full_to_small_width_alphanumerics("８") == "8"
    assert full_to_small_width_alphanumerics("９") == "9"
    assert full_to_small_width_alphanumerics("Ａ") == "A"
    assert full_to_small_width_alphanumerics("Ｂ") == "B"
    assert full_to_small_width_alphanumerics("Ｃ") == "C"
    assert full_to_small_width_alphanumerics("Ｄ") == "D"
    assert full_to_small_width_alphanumerics("Ｅ") == "E"
    assert full_to_small_width_alphanumerics("Ｆ") == "F"
    assert full_to_small_width_alphanumerics("Ｇ") == "G"
    assert full_to_small_width_alphanumerics("Ｈ") == "H"
    assert full_to_small_width_alphanumerics("Ｉ") == "I"
    assert full_to_small_width_alphanumerics("Ｊ") == "J"
    assert full_to_small_width_alphanumerics("Ｋ") == "K"
    assert full_to_small_width_alphanumerics("Ｌ") == "L"
    assert full_to_small_width_alphanumerics("Ｍ") == "M"
    assert full_to_small_width_alphanumerics("Ｎ") == "N"
    assert full_to_small_width_alphanumerics("Ｏ") == "O"
    assert full_to_small_width_alphanumerics("Ｐ") == "P"
    assert full_to_small_width_alphanumerics("Ｑ") == "Q"
    assert full_to_small_width_alphanumerics("Ｒ") == "R"


def test_half_to_full_width_kanas():
    assert half_to_full_width_kanas("ｱ") == "ア"
    assert half_to_full_width_kanas("ｲ") == "イ"
    assert half_to_full_width_kanas("ｳ") == "ウ"
    assert half_to_full_width_kanas("ｴ") == "エ"
    assert half_to_full_width_kanas("ｵ") == "オ"
    assert half_to_full_width_kanas("ｶ") == "カ"
    assert half_to_full_width_kanas("ｷ") == "キ"
    assert half_to_full_width_kanas("ｸ") == "ク"
    assert half_to_full_width_kanas("ｹ") == "ケ"
    assert half_to_full_width_kanas("ｺ") == "コ"
    assert half_to_full_width_kanas("ｻ") == "サ"
    assert half_to_full_width_kanas("ｼ") == "シ"
    assert half_to_full_width_kanas("ｽ") == "ス"
    assert half_to_full_width_kanas("ｾ") == "セ"
    assert half_to_full_width_kanas("ｿ") == "ソ"
    assert half_to_full_width_kanas("ﾀ") == "タ"
    assert half_to_full_width_kanas("ﾁ") == "チ"
    assert half_to_full_width_kanas("ﾂ") == "ツ"
    assert half_to_full_width_kanas("ﾃ") == "テ"
    assert half_to_full_width_kanas("ﾄ") == "ト"
    assert half_to_full_width_kanas("ﾅ") == "ナ"
    assert half_to_full_width_kanas("ﾆ") == "ニ"
    assert half_to_full_width_kanas("ﾇ") == "ヌ"
    assert half_to_full_width_kanas("ﾈ") == "ネ"
    assert half_to_full_width_kanas("ﾉ") == "ノ"
    assert half_to_full_width_kanas("ﾊ") == "ハ"
    assert half_to_full_width_kanas("ﾋ") == "ヒ"
    assert half_to_full_width_kanas("ﾌ") == "フ"
    assert half_to_full_width_kanas("ﾍ") == "ヘ"
    assert half_to_full_width_kanas("ﾎ") == "ホ"
    assert half_to_full_width_kanas("ﾏ") == "マ"
    assert half_to_full_width_kanas("ﾐ") == "ミ"
    assert half_to_full_width_kanas("ﾑ") == "ム"
    assert half_to_full_width_kanas("ﾒ") == "メ"
    assert half_to_full_width_kanas("ﾓ") == "モ"
    assert half_to_full_width_kanas("ﾔ") == "ヤ"
    assert half_to_full_width_kanas("ﾕ") == "ユ"
    assert half_to_full_width_kanas("ﾖ") == "ヨ"
    assert half_to_full_width_kanas("ﾗ") == "ラ"
    assert half_to_full_width_kanas("ﾘ") == "リ"
    assert half_to_full_width_kanas("ﾙ") == "ル"
    assert half_to_full_width_kanas("ﾚ") == "レ"
    assert half_to_full_width_kanas("ﾛ") == "ロ"
    assert half_to_full_width_kanas("ﾜ") == "ワ"
    assert half_to_full_width_kanas("ｦ") == "ヲ"
    assert half_to_full_width_kanas("ﾝ") == "ン"
    assert half_to_full_width_kanas("ｧ") == "ァ"
    assert half_to_full_width_kanas("ｨ") == "ィ"
    assert half_to_full_width_kanas("ｩ") == "ゥ"
    assert half_to_full_width_kanas("ｪ") == "ェ"
    assert half_to_full_width_kanas("ｫ") == "ォ"
    assert half_to_full_width_kanas("ｯ") == "ッ"
    assert half_to_full_width_kanas("ｬ") == "ャ"
    assert half_to_full_width_kanas("ｭ") == "ュ"
    assert half_to_full_width_kanas("ｮ") == "ョ"


def test_normalize_width_all():
    assert normalize_width_all("ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐ") == "abcdefghijklmnop"
    assert normalize_width_all("ｑｒｓｔｕｖｗｘｙｚ") == "qrstuvwxyz"
    assert normalize_width_all("ＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰ") == "ABCDEFGHIJKLMNOP"
    assert normalize_width_all("ＱＲＳＴＵＶＷＸＹＺ") == "QRSTUVWXYZ"
    assert normalize_width_all("ｱｲｳｴｵ") == "アイウエオ"
    assert normalize_width_all("ｶｷｸｹｺ") == "カキクケコ"
    assert normalize_width_all("ｻｼｽｾｿ") == "サシスセソ"
    assert normalize_width_all("ﾀﾁﾂﾃﾄ") == "タチツテト"
    assert normalize_width_all("ﾅﾆﾇﾈﾉ") == "ナニヌネノ"
    assert normalize_width_all("ﾊﾋﾌﾍﾎ") == "ハヒフヘホ"
    assert normalize_width_all("ﾏﾐﾑﾒﾓ") == "マミムメモ"
    assert normalize_width_all("ﾔﾕﾖ") == "ヤユヨ"
    assert normalize_width_all("ﾗﾘﾙﾚﾛ") == "ラリルレロ"
    assert normalize_width_all("ﾜｦﾝ") == "ワヲン"
    assert normalize_width_all("ｧｨｩｪｫ") == "ァィゥェォ"
    assert normalize_width_all("ｯｬｭｮ") == "ッャュョ"
    assert normalize_width_all("１２３４５６７８９０") == "1234567890"

    origin = "ｳﾞｶﾞｷﾞｸﾞｹﾞｺﾞｻﾞｼﾞｽﾞｾﾞｿﾞﾀﾞﾁﾞﾂﾞﾃﾞﾄﾞﾊﾞﾋﾞﾌﾞﾍﾞﾎﾞﾊﾟﾋﾟﾌﾟﾍﾟﾎﾟｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓﾔﾕﾖﾗﾘﾙﾚﾛﾜｦﾝｧｨｩｪｫｬｭｮｯ"
    expected = "ヴガギグゲゴザジズゼゾダヂヅデドバビブベボパピプペポアイウエオカキクケコサシスセソタチツテトナニヌネノハヒフヘホマミムメモヤユヨラリルレロワヲンァィゥェォャュョッ"
    origin2 = "１２３４５６７８９０ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ"
    expected2 = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"

    assert normalize_width_all(origin) == expected
    assert normalize_width_all(origin2) == expected2
